%define name udev
%define version 013
%define bksnap 0
#define bksnap 20040113
%define mdkrelease 4mdk
%define url ftp://ftp.kernel.org/pub/linux/utils/kernel/hotplug
%if %bksnap
%define release 0.bk_%{bksnap}.%{mdkrelease}
%define tarname %{name}-bk_%{bksnap}
%else
%define release %{mdkrelease}
%define tarname %{name}-%{version}
%endif
%define kernel_rel 2.6.2-2mdk
%define kernel_dir /usr/src/linux-%{kernel_rel}
#define kernel_dir /usr/src/linux-2.6

%define use_klibc 0
%define use_dbus 0

%{?_without_dbus:	%{expand: %%global use_dbus 0}}
%{?_without_klibc:	%{expand: %%global use_klibc 0}}

%{?_with_dbus:		%{expand: %%global use_dbus 1}}
%{?_with_klibc:		%{expand: %%global use_klibc 1}}

Name: 		%{name}
Version: 	%{version}
Release: 	%{release}
License: 	GPL
Group:		System/Configuration/Hardware
URL:		%{url}
Source: 	%{url}/%{tarname}.tar.bz2
Source1:	udev.permissions
Source2:	udev.rules.lsb
Source3:	udev.rules.devfs
Patch1:		udev013-use_udev.rules.devfs.patch.bz2
Patch2:		udev013-use_conf.d.patch.bz2
Patch3:		udev013_klibc_kheaders.patch.bz2
Patch4:		udev013_ide-devfs.sh.patch.bz2
Patch5:		udev013_udev_rc_tweak.patch.bz2
Patch6:		udev013_scsi_id-0.3.patch.bz2
Patch10:	udev013_sysfs.h.patch.bz2
Patch11:	udev013_multi.patch.bz2
Patch20:	udev013_clean_klibc_deps.patch.bz2
Patch21:	udev-013-service.patch.bz2
Prereq: 	/bin/sh, fileutils, hotplug, rpm-helper
Requires: 	kernel >= 2.6.0
%if %use_klibc
BuildRequires:	kernel-source = %{kernel_rel}
%endif
%if %use_dbus
BuildRequires:	dbus-devel
%endif
BuildRequires:	glibc-static-devel
BuildRequires:	libsysfs-devel
BuildRoot: 	%{_tmppath}/%{name}-%{version}-build
Summary: 	A userspace implementation of devfs

%description
udev is a implementation of devfs in userspace using sysfs and
/sbin/hotplug. It requires a 2.6 kernel to run properly.

%prep
%setup -q
#patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
#patch10 -p1 -b .sysfs.h
%patch11 -p1 -b .multi
%patch20 -p1
%patch21 -p1 -b .service

%build
%if %use_klibc
%make KERNEL_DIR=%{kernel_dir} USE_KLIBC=true 
install -m 755 udev udev-klibc 
%make clean
%endif

%if %use_dbus
%make USE_DBUS=true EXTRAS=extras/scsi_id 
%else
%make EXTRAS=extras/scsi_id 
%endif

%install
%make DESTDIR=$RPM_BUILD_ROOT install

%if %use_klibc
install -m 755 udev-klibc $RPM_BUILD_ROOT/sbin/
%endif

# init script
rm -rf $RPM_BUILD_ROOT/etc/init.d
install -d $RPM_BUILD_ROOT/%{_initrddir}/
install -m 755 etc/init.d/udev $RPM_BUILD_ROOT/%{_initrddir}/

# scsi_id
install -m 755 extras/scsi_id/scsi_id $RPM_BUILD_ROOT/sbin/
install -m 644 extras/scsi_id/scsi_id.config $RPM_BUILD_ROOT/etc/
install -m 644 extras/scsi_id/scsi_id.8 $RPM_BUILD_ROOT/%{_mandir}/man8/
#scsi_id docs
install -m 644 extras/scsi_id/README README.scsi_id
install -m 644 extras/scsi_id/TODO TODO.scsi_id

%if %use_dbus
install -d  $RPM_BUILD_ROOT/%{_sysconfdir}/dbus-1/system.d/
install -m 644 etc/dbus-1/system.d/%{name}_sysbus_policy.conf $RPM_BUILD_ROOT/%{_sysconfdir}/dbus-1/system.d/
%endif

rm -f $RPM_BUILD_ROOT/etc/%{name}/udev.permissions
rm -f $RPM_BUILD_ROOT/etc/%{name}/udev.rules.devfs

install -m 644 %SOURCE1 $RPM_BUILD_ROOT/etc/%{name}/udev.permissions
install -d $RPM_BUILD_ROOT/etc/%{name}/conf.d
install -m 644 %SOURCE2 $RPM_BUILD_ROOT/etc/%{name}/conf.d/00-lsb
install -m 644 %SOURCE3 $RPM_BUILD_ROOT/etc/%{name}/conf.d/01-devfs
install -d $RPM_BUILD_ROOT/etc/%{name}/scripts
install -m 755  extras/ide-devfs.sh $RPM_BUILD_ROOT/etc/%{name}/scripts/
rm -f $RPM_BUILD_ROOT/etc/hotplug.d/default/udev.hotplug
ln -s /sbin/udev $RPM_BUILD_ROOT/etc/hotplug.d/default/udev.hotplug

%clean
rm -rf $RPM_BUILD_ROOT


%post
%_post_service %name

%preun
%_preun_service %name

%files
%defattr(0644,root,root,0755)
%doc COPYING README TODO ChangeLog docs/overview docs/udev-OLS2003.pdf docs/udev_vs_devfs docs/libsysfs.txt README.scsi_id TODO.scsi_id 
%{_mandir}/man8/udev.8*
%{_mandir}/man8/scsi_id.8*
%attr(0755,root,root) /sbin/*
/%{name}/
%attr(0755,root,root) %config(noreplace) /%{_initrddir}/%{name}
%config(noreplace) /%{_sysconfdir}/scsi_id.config
%config(noreplace) /%{_sysconfdir}/%{name}/udev.*
%config(noreplace) /%{_sysconfdir}/%{name}/conf.d/*
%config(noreplace) %attr(0755,root,root) /%{_sysconfdir}/%{name}/scripts/*
%config(noreplace) /%{_sysconfdir}/hotplug.d/default/udev.hotplug
%if %use_dbus
%config(noreplace) /%{_sysconfdir}/dbus-1/system.d/%{name}_sysbus_policy.conf
%endif

%changelog
* Thu Feb 12 2004 Frederic Lepied <flepied@mandrakesoft.com> 013-4mdk
- don't build with klibc/dbus by default
- subsys support in service

* Mon Jan 19 2004 Svetoslav Slavtchev <svetljo@gmx.de> 013-3mdk
- support for multiple configuration files (Andrej)
- better init script (Andrej)
- scsi_id-0.3
- add --with/--without klibc, dbus
- add some new devfs symlinks
- split udev.rules in devfs & lsb
- some more Makefile's tweaks

* Mon Jan 19 2004 Olivier Blin <blino@mandrake.org> 013-2mdk
- restore some executable perms

* Wed Jan 14 2004 Svetoslav Slavtchev <svetljo@gmx.de> 013-1mdk
- 013
- build klibc binary for initrd (udev-klibc)
  and glibc dynamic binary (udev)
- include scsi_id 
- better devfs like rules
- udev uses the udev.rules.devfs by default
- some tweaks to udev.permissions
- tweak ide-devfs.sh to create all
  the symlinks devfs creates
- add core, fd/*, stdin, stdout, stderr support 
  to init script (stolen from the debian one)
- use dbus, now that we have it 
- From Olivier Blin <blino@mandrake.org> :
    - remove explicit dependency on libdbus package
    - fix BuildRequires (dbus-devel, libsysfs-devel)
    - define %%kernel_rel and %%kernel_dir
    - fix perms in %%files

* Mon Jan 05 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 012-1mdk
- new release

* Mon Dec 29 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 011-1mdk
- new release

* Wed Dec 17 2003 Nicolas Planel <nplanel@mandrakesoft.com> 009-1mdk
- 009.

* Wed Dec 10 2003 Nicolas Planel <nplanel@mandrakesoft.com> 008-1mdk
- 008.

* Fri Nov 28 2003 G�z Waschk <waschk@linux-mandrake.com> 007-2mdk
- buildrequires glibc-static-devel

* Tue Nov 25 2003 Nicolas Planel <nplanel@mandrakesoft.com> 007-1mdk
- 007.

* Wed Nov 19 2003 Nicolas Planel <nplanel@mandrakesoft.com> 006-1mdk
- First version for MandrakeSoft.
